commit 48506c80dea1a9760c62bb68e0ffe6eba5e2e4be
Author: freddy77 <freddy77>
Date:   Tue Aug 18 15:11:12 2009 +0000

    improve ms xml support

diff --git a/ChangeLog b/ChangeLog
index acee624..cc6f105 100644
--- a/ChangeLog
+++ b/ChangeLog
@@ -1,3 +1,8 @@
+Tue Aug 18 17:11:07 CEST 2009    Frediano Ziglio <freddy77_A_gmail_D_com>
+	* src/tds/tds_checks.c src/tds/token.c misc/types.txt:
+	* src/odbc/odbc_util.c:
+	- improve ms xml support
+
 Tue Aug 18 17:07:18 CEST 2009    Frediano Ziglio <freddy77_A_gmail_D_com>
 	* src/tds/token.c: fix silly error
 
@@ -1733,4 +1738,4 @@ Wed Jan  9 19:54:43 EST 2008	JK Lowden <jklowden@freetds.org>
 	* ChangeLog-0.82 added because of release
 	
 $FreeTDS$
-$Id: ChangeLog,v 1.2843 2009/08/18 15:07:11 freddy77 Exp $
+$Id: ChangeLog,v 1.2844 2009/08/18 15:11:12 freddy77 Exp $
diff --git a/src/odbc/odbc_util.c b/src/odbc/odbc_util.c
index 2665bda..901cab2 100644
--- a/src/odbc/odbc_util.c
+++ b/src/odbc/odbc_util.c
@@ -39,7 +39,7 @@
 #include <dmalloc.h>
 #endif
 
-TDS_RCSID(var, "$Id: odbc_util.c,v 1.108 2009/06/10 18:54:38 freddy77 Exp $");
+TDS_RCSID(var, "$Id: odbc_util.c,v 1.109 2009/08/18 15:11:12 freddy77 Exp $");
 
 /**
  * \ingroup odbc_api
@@ -341,6 +341,8 @@ odbc_server_to_sql_type(int col_type, int col_size)
 	case SYBVARIANT:
 		break;
 #endif
+	case SYBMSXML:
+		return SQL_CHAR;
 		/*
 		 * TODO what should I do with these types ?? 
 		 * return other types can cause additional problems
@@ -361,7 +363,6 @@ odbc_server_to_sql_type(int col_type, int col_size)
 	case SYBUNITEXT:
 	case SYBXML:
 	case SYBMSUDT:
-	case SYBMSXML:
 		break;
 	}
 	return SQL_UNKNOWN_TYPE;
@@ -523,6 +524,8 @@ odbc_set_sql_type_info(TDSCOLUMN * col, struct _drecord *drec, SQLINTEGER odbc_v
 		/* SET_INFO("sql_variant", "", ""); */
 		break;
 #endif
+	case SYBMSXML:
+		SET_INFO("xml", "'", "'");
 	}
 	SET_INFO("", "", "");
 #undef SET_INFO
diff --git a/src/tds/tds_checks.c b/src/tds/tds_checks.c
index 628277d..a3bfa1c 100644
--- a/src/tds/tds_checks.c
+++ b/src/tds/tds_checks.c
@@ -44,7 +44,7 @@
 #include <dmalloc.h>
 #endif
 
-TDS_RCSID(var, "$Id: tds_checks.c,v 1.24 2009/08/18 07:26:46 freddy77 Exp $");
+TDS_RCSID(var, "$Id: tds_checks.c,v 1.25 2009/08/18 15:11:12 freddy77 Exp $");
 
 #if ENABLE_EXTRA_CHECKS
 
@@ -199,7 +199,7 @@ tds_check_column_extra(const TDSCOLUMN * column)
 	if (is_blob_type(column->column_type)) {
 		assert(column->column_varint_size >= 4);
 	} else if (column->column_varint_size == 8) {
-		assert(column->on_server.column_type == XSYBVARCHAR || column->on_server.column_type == XSYBVARBINARY || column->on_server.column_type == XSYBNVARCHAR);
+		assert(column->on_server.column_type == XSYBVARCHAR || column->on_server.column_type == XSYBVARBINARY || column->on_server.column_type == XSYBNVARCHAR || column->on_server.column_type == SYBMSXML);
 		varint_ok = 1;
 	} else if (column->column_type == SYBVARIANT) {
 		assert(column->column_varint_size == 4);
diff --git a/src/tds/token.c b/src/tds/token.c
index 6f80816..61dcfb0 100644
--- a/src/tds/token.c
+++ b/src/tds/token.c
@@ -42,7 +42,7 @@
 #include <dmalloc.h>
 #endif
 
-TDS_RCSID(var, "$Id: token.c,v 1.365 2009/08/18 15:07:11 freddy77 Exp $");
+TDS_RCSID(var, "$Id: token.c,v 1.366 2009/08/18 15:11:12 freddy77 Exp $");
 
 #define USE_ICONV tds->use_iconv
 
@@ -1432,6 +1432,9 @@ tds7_get_data_info(TDSSOCKET * tds, TDSCOLUMN * curcol)
 	curcol->column_timestamp = (curcol->column_type == SYBBINARY && curcol->column_usertype == TDS_UT_TIMESTAMP);
 
 	switch (curcol->column_varint_size) {
+	case 8:
+		curcol->column_size = 0x7ffffffflu;
+		break;
 	case 4:
 		curcol->column_size = tds_get_int(tds);
 		break;
@@ -1440,7 +1443,7 @@ tds7_get_data_info(TDSSOCKET * tds, TDSCOLUMN * curcol)
 #ifdef ENABLE_DEVELOPING
 		/* under TDS9 this means ?var???(MAX) */
 		if (curcol->column_size < 0 && IS_TDS90(tds)) {
-			curcol->column_size = 0x1ffffffflu;
+			curcol->column_size = 0x3ffffffflu;
 			curcol->column_varint_size = 8;
 		}
 #endif
@@ -1485,7 +1488,8 @@ tds7_get_data_info(TDSSOCKET * tds, TDSCOLUMN * curcol)
 			tds_get_byte(tds);
 		curcol->table_namelen =
 			tds_get_string(tds, tds_get_smallint(tds), curcol->table_name, sizeof(curcol->table_name) - 1);
-	}
+	} else if (IS_TDS90(tds) && curcol->column_type == SYBMSXML)
+		tds_get_byte(tds);
 
 	/*
 	 * under 7.0 lengths are number of characters not

